# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ros_statistics_msgs/HostStatistics.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class HostStatistics(genpy.Message):
  _md5sum = "db625f59b6c5c3e06353703e3237bba0"
  _type = "ros_statistics_msgs/HostStatistics"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """string hostname
string ipaddress

time window_start
time window_stop

uint16 samples

# Load per CPU
float32[] cpu_load_mean
float32[] cpu_load_std
float32[] cpu_load_max

# mem_avialable
float64 phymem_used_mean
float64 phymem_used_std
float64 phymem_used_max
float64 phymem_avail_mean
float64 phymem_avail_std
float64 phymem_avail_max
"""
  __slots__ = ['hostname','ipaddress','window_start','window_stop','samples','cpu_load_mean','cpu_load_std','cpu_load_max','phymem_used_mean','phymem_used_std','phymem_used_max','phymem_avail_mean','phymem_avail_std','phymem_avail_max']
  _slot_types = ['string','string','time','time','uint16','float32[]','float32[]','float32[]','float64','float64','float64','float64','float64','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       hostname,ipaddress,window_start,window_stop,samples,cpu_load_mean,cpu_load_std,cpu_load_max,phymem_used_mean,phymem_used_std,phymem_used_max,phymem_avail_mean,phymem_avail_std,phymem_avail_max

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(HostStatistics, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.hostname is None:
        self.hostname = ''
      if self.ipaddress is None:
        self.ipaddress = ''
      if self.window_start is None:
        self.window_start = genpy.Time()
      if self.window_stop is None:
        self.window_stop = genpy.Time()
      if self.samples is None:
        self.samples = 0
      if self.cpu_load_mean is None:
        self.cpu_load_mean = []
      if self.cpu_load_std is None:
        self.cpu_load_std = []
      if self.cpu_load_max is None:
        self.cpu_load_max = []
      if self.phymem_used_mean is None:
        self.phymem_used_mean = 0.
      if self.phymem_used_std is None:
        self.phymem_used_std = 0.
      if self.phymem_used_max is None:
        self.phymem_used_max = 0.
      if self.phymem_avail_mean is None:
        self.phymem_avail_mean = 0.
      if self.phymem_avail_std is None:
        self.phymem_avail_std = 0.
      if self.phymem_avail_max is None:
        self.phymem_avail_max = 0.
    else:
      self.hostname = ''
      self.ipaddress = ''
      self.window_start = genpy.Time()
      self.window_stop = genpy.Time()
      self.samples = 0
      self.cpu_load_mean = []
      self.cpu_load_std = []
      self.cpu_load_max = []
      self.phymem_used_mean = 0.
      self.phymem_used_std = 0.
      self.phymem_used_max = 0.
      self.phymem_avail_mean = 0.
      self.phymem_avail_std = 0.
      self.phymem_avail_max = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.hostname
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.ipaddress
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4IH.pack(_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs, _x.samples))
      length = len(self.cpu_load_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.cpu_load_mean))
      length = len(self.cpu_load_std)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.cpu_load_std))
      length = len(self.cpu_load_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.cpu_load_max))
      _x = self
      buff.write(_struct_6d.pack(_x.phymem_used_mean, _x.phymem_used_std, _x.phymem_used_max, _x.phymem_avail_mean, _x.phymem_avail_std, _x.phymem_avail_max))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.window_start is None:
        self.window_start = genpy.Time()
      if self.window_stop is None:
        self.window_stop = genpy.Time()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.hostname = str[start:end].decode('utf-8')
      else:
        self.hostname = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.ipaddress = str[start:end].decode('utf-8')
      else:
        self.ipaddress = str[start:end]
      _x = self
      start = end
      end += 18
      (_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs, _x.samples,) = _struct_4IH.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_load_mean = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_load_std = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_load_max = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 48
      (_x.phymem_used_mean, _x.phymem_used_std, _x.phymem_used_max, _x.phymem_avail_mean, _x.phymem_avail_std, _x.phymem_avail_max,) = _struct_6d.unpack(str[start:end])
      self.window_start.canon()
      self.window_stop.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.hostname
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.ipaddress
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4IH.pack(_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs, _x.samples))
      length = len(self.cpu_load_mean)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.cpu_load_mean.tostring())
      length = len(self.cpu_load_std)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.cpu_load_std.tostring())
      length = len(self.cpu_load_max)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.cpu_load_max.tostring())
      _x = self
      buff.write(_struct_6d.pack(_x.phymem_used_mean, _x.phymem_used_std, _x.phymem_used_max, _x.phymem_avail_mean, _x.phymem_avail_std, _x.phymem_avail_max))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.window_start is None:
        self.window_start = genpy.Time()
      if self.window_stop is None:
        self.window_stop = genpy.Time()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.hostname = str[start:end].decode('utf-8')
      else:
        self.hostname = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.ipaddress = str[start:end].decode('utf-8')
      else:
        self.ipaddress = str[start:end]
      _x = self
      start = end
      end += 18
      (_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs, _x.samples,) = _struct_4IH.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_load_mean = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_load_std = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.cpu_load_max = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      _x = self
      start = end
      end += 48
      (_x.phymem_used_mean, _x.phymem_used_std, _x.phymem_used_max, _x.phymem_avail_mean, _x.phymem_avail_std, _x.phymem_avail_max,) = _struct_6d.unpack(str[start:end])
      self.window_start.canon()
      self.window_stop.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_6d = struct.Struct("<6d")
_struct_4IH = struct.Struct("<4IH")
