# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ros_statistics_msgs/NodeStatistics.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class NodeStatistics(genpy.Message):
  _md5sum = "7bd20bf65465385d0a0d97df0064e759"
  _type = "ros_statistics_msgs/NodeStatistics"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """string node
string host
string uri
string pid

# Statistics apply to this time window
time window_start
time window_stop

uint16 samples

uint16 threads

# Process CPU usage, as percentage of total local use
float32 cpu_load_mean
float32 cpu_load_std
float32 cpu_load_max

# Virtual Memory use
float64 virt_mem_mean
float32 virt_mem_std
float64 virt_mem_max

# Real Memory Use
float64 real_mem_mean
float32 real_mem_std
float64 real_mem_max

"""
  __slots__ = ['node','host','uri','pid','window_start','window_stop','samples','threads','cpu_load_mean','cpu_load_std','cpu_load_max','virt_mem_mean','virt_mem_std','virt_mem_max','real_mem_mean','real_mem_std','real_mem_max']
  _slot_types = ['string','string','string','string','time','time','uint16','uint16','float32','float32','float32','float64','float32','float64','float64','float32','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       node,host,uri,pid,window_start,window_stop,samples,threads,cpu_load_mean,cpu_load_std,cpu_load_max,virt_mem_mean,virt_mem_std,virt_mem_max,real_mem_mean,real_mem_std,real_mem_max

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(NodeStatistics, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.node is None:
        self.node = ''
      if self.host is None:
        self.host = ''
      if self.uri is None:
        self.uri = ''
      if self.pid is None:
        self.pid = ''
      if self.window_start is None:
        self.window_start = genpy.Time()
      if self.window_stop is None:
        self.window_stop = genpy.Time()
      if self.samples is None:
        self.samples = 0
      if self.threads is None:
        self.threads = 0
      if self.cpu_load_mean is None:
        self.cpu_load_mean = 0.
      if self.cpu_load_std is None:
        self.cpu_load_std = 0.
      if self.cpu_load_max is None:
        self.cpu_load_max = 0.
      if self.virt_mem_mean is None:
        self.virt_mem_mean = 0.
      if self.virt_mem_std is None:
        self.virt_mem_std = 0.
      if self.virt_mem_max is None:
        self.virt_mem_max = 0.
      if self.real_mem_mean is None:
        self.real_mem_mean = 0.
      if self.real_mem_std is None:
        self.real_mem_std = 0.
      if self.real_mem_max is None:
        self.real_mem_max = 0.
    else:
      self.node = ''
      self.host = ''
      self.uri = ''
      self.pid = ''
      self.window_start = genpy.Time()
      self.window_stop = genpy.Time()
      self.samples = 0
      self.threads = 0
      self.cpu_load_mean = 0.
      self.cpu_load_std = 0.
      self.cpu_load_max = 0.
      self.virt_mem_mean = 0.
      self.virt_mem_std = 0.
      self.virt_mem_max = 0.
      self.real_mem_mean = 0.
      self.real_mem_std = 0.
      self.real_mem_max = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.node
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.host
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.uri
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.pid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4I2H3fdf2dfd.pack(_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs, _x.samples, _x.threads, _x.cpu_load_mean, _x.cpu_load_std, _x.cpu_load_max, _x.virt_mem_mean, _x.virt_mem_std, _x.virt_mem_max, _x.real_mem_mean, _x.real_mem_std, _x.real_mem_max))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.window_start is None:
        self.window_start = genpy.Time()
      if self.window_stop is None:
        self.window_stop = genpy.Time()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.node = str[start:end].decode('utf-8')
      else:
        self.node = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.host = str[start:end].decode('utf-8')
      else:
        self.host = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.uri = str[start:end].decode('utf-8')
      else:
        self.uri = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pid = str[start:end].decode('utf-8')
      else:
        self.pid = str[start:end]
      _x = self
      start = end
      end += 72
      (_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs, _x.samples, _x.threads, _x.cpu_load_mean, _x.cpu_load_std, _x.cpu_load_max, _x.virt_mem_mean, _x.virt_mem_std, _x.virt_mem_max, _x.real_mem_mean, _x.real_mem_std, _x.real_mem_max,) = _struct_4I2H3fdf2dfd.unpack(str[start:end])
      self.window_start.canon()
      self.window_stop.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.node
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.host
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.uri
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.pid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4I2H3fdf2dfd.pack(_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs, _x.samples, _x.threads, _x.cpu_load_mean, _x.cpu_load_std, _x.cpu_load_max, _x.virt_mem_mean, _x.virt_mem_std, _x.virt_mem_max, _x.real_mem_mean, _x.real_mem_std, _x.real_mem_max))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.window_start is None:
        self.window_start = genpy.Time()
      if self.window_stop is None:
        self.window_stop = genpy.Time()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.node = str[start:end].decode('utf-8')
      else:
        self.node = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.host = str[start:end].decode('utf-8')
      else:
        self.host = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.uri = str[start:end].decode('utf-8')
      else:
        self.uri = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pid = str[start:end].decode('utf-8')
      else:
        self.pid = str[start:end]
      _x = self
      start = end
      end += 72
      (_x.window_start.secs, _x.window_start.nsecs, _x.window_stop.secs, _x.window_stop.nsecs, _x.samples, _x.threads, _x.cpu_load_mean, _x.cpu_load_std, _x.cpu_load_max, _x.virt_mem_mean, _x.virt_mem_std, _x.virt_mem_max, _x.real_mem_mean, _x.real_mem_std, _x.real_mem_max,) = _struct_4I2H3fdf2dfd.unpack(str[start:end])
      self.window_start.canon()
      self.window_stop.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_4I2H3fdf2dfd = struct.Struct("<4I2H3fdf2dfd")
